/*This is the Casio Star Wars Game*/

#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/std/stdlib.h>
#include <gint/std/stdio.h>
#include "tick.h"


#define LAPSE_SHOOT 50
#define SPEED 3


extern bopti_image_t img_SpaceShip;
extern bopti_image_t img_EnnemiShip;
extern bopti_image_t img_naboo;

struct positiond{
  short x;
  short y;
  short d;
};

unsigned int random(int seed);
char check_death(struct positiond vaisseau,struct positiond * bulletMap);
char playerIsDead(struct positiond * bulletMap,int playerPos);
void addbullet(struct positiond * tab,int x, int y,int d);
void addExplosion(struct positiond * tab, int x, int y,int power);
void printscore(int nb);
void explode(struct positiond * tab);
void manageInput(int * playerPos, int * TimeBeforeDie,char * TimeBeforeShoot, struct positiond * bullets, struct positiond * explosionList);
void ennemiShoot(char * bootshoot, struct positiond * ennemiMap, struct positiond * bullets);
void manageLive(struct positiond * bullets, struct positiond * explosionList, int playerPos, int * TimeBeforeDie);
void moveAndKillAndDisplay(struct positiond * bullets, struct positiond * ennemiMap, struct positiond * explosionList, int * score, int playerPos, int *TimeBeforeDie);
void spawnEnnemies(struct positiond * ennemiMap);



char bootshoot=(LAPSE_SHOOT*2)/SPEED;
char string[20];
int lastrandom;
char TimeBeforeShoot=LAPSE_SHOOT/SPEED;
int timer;
int level=0;
char continuer1;

unsigned int random(int seed){
  if(seed>0){lastrandom = seed;}
  lastrandom = ( 0x41C64E6D * lastrandom ) + 0x3039;
  return (lastrandom >> 16);
}  // function found on the net, but works nicely


char check_death(struct positiond vaisseau,struct positiond * bulletMap){
  for (int i=0; i<30;i++){
    if (bulletMap[i].d>0 &&(vaisseau.x<bulletMap[i].x-10) && (vaisseau.y<bulletMap[i].y) && (vaisseau.y>bulletMap[i].y-40) && vaisseau.x>=50){bulletMap[i].x=-1;return 1;}
 
}
 return 0;
}


char playerIsDead(struct positiond * bulletMap,int playerPos){
  for (int i=0;i<30;i++){
    if (bulletMap[i].d<=0 && (bulletMap[i].x<=65) && bulletMap[i].x>=50 && (playerPos>=bulletMap[i].y-40) && (playerPos<=bulletMap[i].y)){bulletMap[i].x=-1;return 1;}}  
  return 0;
  }


void addbullet(struct positiond * tab,int x, int y,int d){
  for (int i=0;i<30;i++){
    if ((tab[i]).x<=0 || tab[i].x>=379){
      (tab[i]).x=x;
      (tab[i]).y=y;
      (tab[i]).d=d;
      break;
    }
  }
}


void addExplosion(struct positiond * tab, int x, int y,int power){
  for (int i=0;i<10;i++){
    if (tab[i].d==0){
      tab[i].x=x;
      tab[i].y=y;
      tab[i].d=power;
      break;
    }
  }
}


void printscore(int nb){
  sprintf(string,"%d",nb);
  dtext(50,20,C_WHITE,string);
}


void explode(struct positiond * tab){
  for (int i=0;i<10;i++){
    if (tab[i].d>0){
      for (int j=0;j<tab[i].d;j++){
        dpixel(tab[i].x+20+((random(-1)%50)-random(-1)%50),tab[i].y+((random(-1)%50)-random(-1)%50),C_RED);
      }
      tab[i].d-=10;
    }
  }
}


void manageInput(int * playerPos, int * TimeBeforeDie,char * TimeBeforeShoot, struct positiond * bullets, struct positiond * explosionList){
  if (keydown(KEY_UP) && *playerPos>0){
	  *playerPos-=SPEED;
  }
  if (keydown(KEY_DOWN) && (*playerPos<184)){
	  *playerPos+=SPEED;
  }
  if (keydown(KEY_EXIT) && *TimeBeforeDie==-1){
    *TimeBeforeDie=250;
    addExplosion(explosionList,70,*playerPos+20,250);

  }
  if (keydown(KEY_SHIFT) && *TimeBeforeShoot<=1 && *TimeBeforeDie==-1){
	  addbullet(bullets,70,*playerPos,2*SPEED);
    addbullet(bullets,70,*playerPos+37,2*SPEED);
    *TimeBeforeShoot=LAPSE_SHOOT/SPEED;
}
}

void manageLive(struct positiond * bullets, struct positiond * explosionList, int playerPos, int * TimeBeforeDie){
  if( playerIsDead(bullets,playerPos) && *TimeBeforeDie==-1){
    addExplosion(explosionList,70,playerPos+20,250);
    *TimeBeforeDie=250;
  }
  if (*TimeBeforeDie>0){
    *TimeBeforeDie=*TimeBeforeDie-1;
  }
}



void ennemiShoot(char * bootshoot, struct positiond * ennemiMap, struct positiond * bullets){
  if (*bootshoot<=0){
    for (int i=0;i<30;i++){
      if (ennemiMap[i].x!=-1){
        addbullet(bullets,ennemiMap[i].x+10,ennemiMap[i].y+20,-2*SPEED);
        *bootshoot=(2*LAPSE_SHOOT)/SPEED;
      }
    }
  }
}

void moveAndKillAndDisplay(struct positiond * bullets, struct positiond * ennemiMap, struct positiond * explosionList, int * score, int playerPos, int *TimeBeforeDie){
  for (int i = 0; i<30;i++ ){
	  if (bullets[i].x>0){
      if (bullets[i].d>0){
	      drect(bullets[i].x,bullets[i].y,bullets[i].x+5,bullets[i].y+2,C_RED);
      }
      else{
        drect(bullets[i].x,bullets[i].y,bullets[i].x+5,bullets[i].y+2,C_GREEN);
      }
	    bullets[i].x+=bullets[i].d;
      if (bullets[i].x>389 || bullets[i].x<=0){
        bullets[i].x=-1;
      }
    }
    if (ennemiMap[i].x!=-1){
        dimage(ennemiMap[i].x,ennemiMap[i].y,&img_EnnemiShip);
        ennemiMap[i].x+=ennemiMap[i].d;
        if(check_death(ennemiMap[i],bullets)){*score=*score+1;addExplosion(explosionList,ennemiMap[i].x,ennemiMap[i].y+20,80);ennemiMap[i].x=-1;}
    }
  }
  if (*TimeBeforeDie==-1){
    dimage(50,playerPos,&img_SpaceShip);}
  manageLive(bullets,explosionList,playerPos,TimeBeforeDie);    

}

void spawnEnnemies(struct positiond * ennemiMap){
  if (random(-1)%(100/SPEED)==0){
    for (int i=0;i<30;i++){
      if(ennemiMap[i].x<=0){
        ennemiMap[i].y=random(-1)%184;
        ennemiMap[i].x=379;
        ennemiMap[i].d=-1*SPEED;
        break;
      }
    }
  }
}






int main(void){
  string[0]='N';string[1]='O';string[2]='T';string[3]='H';string[4]='I';string[5]='N';string[6]='G';string[7]='\0'; //string="NOTHING" in python3

  //Let's allocate
  struct positiond * bullets;
  bullets=malloc(sizeof(struct positiond)*30);
  struct positiond * ennemiMap;
  ennemiMap=malloc(sizeof(struct positiond)*30);
  struct positiond * explosionList;
  explosionList=malloc(sizeof(struct positiond) * 10);

  
//Loop for being able to play several times without exiting.
  while(1){
  random(time_getTicks()); //random initialisation with ticks
  int TimeBeforeDie=-1;
  //We now have to reset ennemiMap and bullets
  for (int i=0;i<30;i++){
    bullets[i].x=-1;
    bullets[i].y=-1;
    bullets[i].d=1;
    ennemiMap[i].x=-1;
    ennemiMap[i].y=-1;
    ennemiMap[i].d=-1;
  }
  
  //for explosion, a different loop: 10 of size instead of 30
  for (int i=0;i<10;i++){
    explosionList[i].d=0;
  }
  
  
  int playerPos=100; //yplayer
  int score=0;
  
  
  //display a nice welcome text
  dimage(0,0,&img_naboo);
  dtext(50,100,C_RED,"Appuyez sur une touche pour jouer");
  dtext(1,200,C_RED,"Benoit Poreaux");
  dtext(100,150 ,C_RED,"VOTRE PRECEDENT SCORE ETAIT");
  dtext(324,150,C_RED,string);
  dupdate();
  getkey(); //wait the user to press

  while (TimeBeforeDie!=225)//MAIN LOOP!
    {
      if (TimeBeforeShoot>=0){
      TimeBeforeShoot--;}
      bootshoot--;
      dimage(0,0,&img_naboo);
      manageInput(&playerPos, &TimeBeforeDie,&TimeBeforeShoot, bullets, explosionList);
      ennemiShoot(&bootshoot, ennemiMap,bullets);
      moveAndKillAndDisplay(bullets,ennemiMap,explosionList, &score,playerPos,&TimeBeforeDie);
      spawnEnnemies(ennemiMap);
      printscore(score);
      explode(explosionList);
      dupdate();
      clearevents();
    }
    getkey();
  }
  return 1;

}